import { HttpRequest } from "./aws/utils";
import { ResourceLimits } from "worker_threads";
export type { HttpRequest } from "./aws/utils";
export type SignerOptions = {
    minThreads?: number;
    maxThreads?: number;
    idleTimeout?: number;
    maxQueue?: number | "auto";
    concurrentTasksPerWorker?: number;
    resourceLimits?: ResourceLimits;
};
export declare class Signer {
    private readonly worker;
    cpuCount: number;
    constructor(options?: SignerOptions);
    private millsToNextDay;
    request(request: HttpRequest, service: string, region?: string, date?: Date): Promise<HttpRequest>;
    destroy(): Promise<void>;
}
export declare class SignerSingleton {
    private static signer;
    constructor();
    static getSigner(options?: SignerOptions): Signer;
}
